'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bcoin = require('bcoin');

var _bpanelUi = require('@bpanel/bpanel-ui');

var _helpers = require('./helpers');

var _bpanelUtils = require('@bpanel/bpanel-utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PublishData = function (_React$PureComponent) {
  (0, _inherits3.default)(PublishData, _React$PureComponent);

  function PublishData(props) {
    (0, _classCallCheck3.default)(this, PublishData);

    var _this = (0, _possibleConstructorReturn3.default)(this, (PublishData.__proto__ || (0, _getPrototypeOf2.default)(PublishData)).call(this, props));

    _this.state = { scripts: [], tx: '', wallets: [], wallet: '', rate: 1000 };
    _this.client = null;
    _this.setWalletsBound = _this.setWallets.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(PublishData, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.client = (0, _bpanelUtils.getClient)();
      this.setWallets();
      this.client.on('set clients', this.setWalletsBound);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.client.removeListener('set clients', this.setWalletsBound);
    }
  }, {
    key: 'setWallets',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var wallets;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.client.wallet.getWallets();

              case 2:
                wallets = _context.sent;

                this.setState({ wallets: wallets, wallet: wallets[0] });

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function setWallets() {
        return _ref.apply(this, arguments);
      }

      return setWallets;
    }()
  }, {
    key: 'onChange',
    value: function onChange(e) {
      var input = e.target.value;
      var scripts = (0, _helpers.scriptsFromString)(input);
      this.setState({ scripts: scripts });
    }
  }, {
    key: 'onSelect',
    value: function onSelect(e) {
      this.setState({ wallet: e.target.value });
    }
  }, {
    key: 'setFee',
    value: function setFee(e) {
      this.setState({ rate: e.target.value });
    }
  }, {
    key: 'onClick',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var _state, scripts, wallet, rate, outputs, options, tx;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _state = this.state, scripts = _state.scripts, wallet = _state.wallet, rate = _state.rate;
                outputs = scripts.map(function (script) {
                  return _bcoin.Output.fromScript(script, 0);
                });
                options = {
                  rate: parseInt(rate),
                  sort: false,
                  outputs: outputs
                };
                _context2.prev = 3;
                _context2.next = 6;
                return this.client.wallet.send(wallet, options);

              case 6:
                tx = _context2.sent;

                this.setState({ tx: tx });
                _context2.next = 13;
                break;

              case 10:
                _context2.prev = 10;
                _context2.t0 = _context2['catch'](3);

                // eslint-disable-next-line
                console.error('There was an error sending the tx: ', _context2.t0);

              case 13:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[3, 10]]);
      }));

      function onClick() {
        return _ref2.apply(this, arguments);
      }

      return onClick;
    }()
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state2 = this.state,
          wallets = _state2.wallets,
          tx = _state2.tx,
          scripts = _state2.scripts,
          rate = _state2.rate;

      return _react2.default.createElement(
        'div',
        { className: 'publish-data-container' },
        _react2.default.createElement(
          _bpanelUi.Header,
          { type: 'h3' },
          'Publish Arbitrary Data to the Blockchain'
        ),
        _react2.default.createElement(
          _bpanelUi.Text,
          { type: 'p' },
          'Select a wallet to send from: '
        ),
        _react2.default.createElement(
          'select',
          { name: 'wallets', onChange: function onChange(e) {
              return _this2.onSelect(e);
            } },
          wallets.map(function (id) {
            return _react2.default.createElement(
              'option',
              { key: id, value: id },
              id
            );
          })
        ),
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _bpanelUi.Text,
            null,
            'Rate (satoshis/kb): '
          ),
          _react2.default.createElement('input', {
            type: 'number',
            step: '100',
            value: rate,
            onChange: function onChange(e) {
              return _this2.setFee(e);
            }
          })
        ),
        _react2.default.createElement('textarea', {
          placeholder: 'Enter the data to be published here.',
          style: { width: '100%' },
          onChange: function onChange(e) {
            return _this2.onChange(e);
          }
        }),
        _react2.default.createElement(
          _bpanelUi.Header,
          { type: 'h4' },
          'Scripts:'
        ),
        scripts.map(function (script, index) {
          return _react2.default.createElement(
            _bpanelUi.Text,
            { key: index, type: 'p', style: { wordWrap: 'break-word' } },
            index + 1,
            ': ',
            script.toString()
          );
        }),
        _react2.default.createElement(
          _bpanelUi.Button,
          { onClick: function onClick() {
              return _this2.onClick();
            } },
          'Submit'
        ),
        tx && _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _bpanelUi.Header,
            { type: 'h3' },
            'TX Sent:'
          ),
          _react2.default.createElement(
            _bpanelUi.Text,
            { type: 'p', style: { wordWrap: 'break-all' } },
            tx.hash,
            ' '
          )
        )
      );
    }
  }]);
  return PublishData;
}(_react2.default.PureComponent);

exports.default = PublishData;