'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.scriptsFromString = scriptsFromString;

var _bcoin = require('bcoin');

var _bufio = require('bufio');

var _bufio2 = _interopRequireDefault(_bufio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function scriptsFromString(input) {
  var dataLength = _bcoin.policy.MAX_OP_RETURN;
  var scriptCount = Math.ceil(input.length / dataLength);
  var strings = [];
  if (scriptCount < 1) strings.push(input);else {
    for (var i = 0; i < scriptCount; i++) {
      var string = void 0;
      if (i === 0) string = input.substr(0, dataLength);else string = input.substr(i * dataLength, dataLength);
      strings.push(string);
    }
  }
  var scripts = [];
  strings.forEach(function (string) {
    var bw = _bufio2.default.write();
    var buffer = bw.writeString(string, 'ascii');
    var data = buffer.render();
    var script = _bcoin.Script.fromNulldata(data);
    scripts.push(script);
  });
  return scripts;
}